<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Task 30.10</title>
</head>

<body>
    <form action="" id="formId">
        <div class="container mt-3">
            <div class="row justify-content-center">
                <div class="col-md-6">
                    <div class="form-group">
                        <label for="exampleInputEmail1">Email address</label>
                        <input type="email" class="form-control" aria-describedby="emailHelp" placeholder="Enter email"
                            id="username">
                    </div>
                    <div class="form-group">
                        <label for="exampleInputPassword1">Password</label>
                        <input type="password" class="form-control" id="password" placeholder="Password">
                    </div>
                    <button type="submit" class="btn btn-primary">Submit</button>
    </form>
    </div>
    </div>
    </div>
    <script>
        "use strict";
        //Vùng 1: Khai báo biến global
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_STATUS_CREATED = 201;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
        const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";

        var loginForm = document.getElementById("formId");
        //Vùng 2: Gọi các hàm xử lý sự kiện
        loginForm.addEventListener("submit", (e) => {
            // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
            e.preventDefault();
            var vUserObject = {
                username: "",
                password: ""
            }
            getDataFromForm(vUserObject);
            var vValidate = validateData(vUserObject);
            if (vValidate == true) {
                //Goi API

                var vXmlHttpLogin = new XMLHttpRequest();
                callLoginAPI(vXmlHttpLogin, vUserObject);
                vXmlHttpLogin.onreadystatechange =
                    function () {

                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                            xuLyKetQuaTraVe(vXmlHttpLogin);
                        }
                    }
            }
            // Tiếp theo thực hiện 4 bước để gọi api login
            //B1: Lấy dữ liệu
            //B2: Validate

            //B3: Xử ly du lieu
        });
        //Vùng 3: Khai báo các hàm xử lý sự kiện
        //Vùng 4: Định nghĩa các hàm dùng chung

        function getDataFromForm(paramUserObject) {
            var vUsernameElement = document.getElementById("username");
            var vPasswordElement = document.getElementById("password");
            paramUserObject.username = vUsernameElement.value;
            paramUserObject.password = vPasswordElement.value;
        }

        function validateData(paramUserObject) {
            if (ValidateEmail(paramUserObject.username) == false) {
                alert("Invalid emai");
                return false;
            }
            return true;
        }

        function ValidateEmail(mail) {
            if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
                return (true)
            }
            alert("You have entered an invalid email address!")
            return (false)
        }

        function callLoginAPI(paramXMLHttpRequest, paramUserObject) {
            var vParams = new URLSearchParams(paramUserObject);
            paramXMLHttpRequest.open("GET", gBASE_URL + "?" + vParams.toString(), true);
            paramXMLHttpRequest.send();
        }

        function xuLyKetQuaTraVe(paramXMLHttpRequest) {
            var vLoginInfo = vXmlHttpLogin.responseText;
                            console.log(vLoginInfo);
                            
        }
    </script>
</body>

</html>